<template>
  <div class="createPost-container">
    <div>
      <b-form ref="taskForm" :model="taskForm" :rules="rules">
        <b-form-group :label="$t('form.title')" label-for="title">
          <b-form-input v-model="taskForm.title" :placeholder="$t('form.title')" required />
        </b-form-group>

        <b-form-group :label="$t('form.explain')" label-for="explain">
          <b-form-textarea v-model="taskForm.explain" :placeholder="$t('form.explain')" required />
        </b-form-group>

        <b-form-group :label="$t('form.region')" label-for="region">
          <v-select v-model="taskForm.region" :filterable="false" :options="regions" @search="onSearchRegions">
            <template slot="no-regions">
              {{ $t('form.typeToSearch') }}
            </template>
            <template slot="option" slot-scope="option">
              <div class="d-center">
                {{ option.region }}
              </div>
            </template>
            <template slot="selected-option" slot-scope="option">
              <div class="selected d-center">
                {{ option.region }}
              </div>
            </template>
          </v-select>
        </b-form-group>

        <b-form-group :label="$t('form.address')" label-for="address">
          <v-select v-model="taskForm.address" :filterable="false" :options="optionsAddress" @search="onSearchAddress">
            <template slot="no-options">
              {{ $t('form.typeToSearch') }}
            </template>
            <template slot="option" slot-scope="option">
              <div class="d-center">
                {{ option.address }}
              </div>
            </template>
            <template slot="selected-option" slot-scope="option">
              <div class="selected d-center">
                {{ option.address }}
              </div>
            </template>
          </v-select>
        </b-form-group>

        <!--<b-form-group :label="$t('form.bani')" label-for="bani">-->
        <!--<v-select v-model="taskForm.bani" :filterable="false" :options="options" @search="onSearch">-->
        <!--<template slot="no-options">-->
        <!--{{ $t('form.typeToSearch') }}-->
        <!--</template>-->
        <!--<template slot="option" slot-scope="option">-->
        <!--<div class="d-center">-->
        <!--{{ option.name }}-->
        <!--</div>-->
        <!--</template>-->
        <!--<template slot="selected-option" slot-scope="option">-->
        <!--<div class="selected d-center">-->
        <!--{{ option.name }}-->
        <!--</div>-->
        <!--</template>-->
        <!--</v-select>-->
        <!--</b-form-group>-->

        <b-form-group :label="$t('form.date')" label-for="date">
          <date-picker v-model="taskForm.date" type="datetime" :placeholder="$t('form.date')" required />
        </b-form-group>

        <b-form-group :label="$t('form.deadline')" label-for="deadline">
          <b-form-input v-model="taskForm.deadline" type="text" :placeholder="$t('form.deadline')" required />
        </b-form-group>

        <span class="btn btn-primary pointer" type="submit" variant="primary" @click="submitForm">{{ $t('form.submit') }}</span>
        <span class="btn btn-danger pointer" type="reset" variant="danger" @click="onCancel">{{ $t('form.cancel') }}</span>
      </b-form>
    </div>
  </div>
</template>

<script>
import Task from '@/api/task';
import 'vue-select/src/scss/vue-select.scss';

const taskApi = new Task('tasks');

export default {
  name: 'TaskDetail',

  components: { },
  props: {
    isEdit: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    const validateRequire = (rule, value, callback) => {
      if (value === '') {
        this.$message({
          message: rule.field + ' is required',
          type: 'error',
        });
        callback(new Error(rule.field + ' is required'));
      } else {
        callback();
      }
    };
    return {
      loading: false,
      taskForm: {},
      rules: {
        title: [{ validator: validateRequire }],
        explain: [{ validator: validateRequire }],
      },
      tempRoute: {},
      options: [],
      optionsAddress: [],
      regions: [],
      item: {
        value: '',
        text: '',
      },
    };
  },
  computed: {
    contentShortLength() {
      return this.taskForm.content_short.length;
    },
    lang() {
      return this.$store.getters.language;
    },
  },
  created() {
    if (this.isEdit) {
      // const id = this.$route.params && this.$route.params.id;
      // this.fetchData(id);
    } else {
      // this.postForm = Object.assign({}, defaultForm);
    }

    // Why need to make a copy of this.$route here?
    // Because if you enter this page and quickly switch tag, may be in the execution of the setTagsViewTitle function, this.$route is no longer pointing to the current page
    this.tempRoute = Object.assign({}, this.$route);
  },
  methods: {
    changBani() {
      alert(this.taskForm.baniItem);
    },
    onSubmit() {
      this.$message('submit!');
    },
    onCancel() {
      this.$message({
        message: 'cancel!',
        type: 'warning',
      });
    },
    onSearch(search, loading) {
      fetch(
        '/api/autoComplete/bani?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        loading(false);
      });
    },
    onSearchAddress(search, loading) {
      fetch(
        '/api/autoComplete/address?q=' + search
      ).then(res => {
        res.json().then(json => (this.optionsAddress = json.items));
        loading(false);
      });
    },
    onSearchRegions(search, loading) {
      fetch(
        '/api/autoComplete/region?q=' + search
      ).then(res => {
        res.json().then(json => (this.regions = json.items));
        loading(false);
      });
    },
    submitForm() {
      this.loading = true;
      taskApi
        .store(this.taskForm)
        .then(response => {
          this.$message({
            message: 'New Task has been created successfully.',
            type: 'success',
            duration: 5 * 1000,
          });
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.userCreating = false;
        });
    },
  },
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import "~@/styles/mixin.scss";
.createPost-container {
  position: relative;
  .createPost-main-container {
    padding: 0 45px 20px 50px;
    .postInfo-container {
      position: relative;
      @include clearfix;
      margin-bottom: 10px;
      .postInfo-container-item {
        float: left;
      }
    }
  }
  .word-counter {
    width: 40px;
    position: absolute;
    right: -10px;
    top: 0px;
  }
}
</style>
<style>
.createPost-container label.el-form-item__label {
  text-align: left;
}
</style>
